<?php

class Images extends MY_Controller { //hook eseten: sima Controller kell

    public function  __construct() {
		parent::__construct();
		$this->load->model('images_model');
		$this->load->helper('url');
		$this->load->helper('form');
		$this->load->helper('html');
		$this->load->library('request');
    }

    public function index($album_id) {
		$images = $this->images_model->get_images((int)$album_id);

		$data = array(
			'album_id'	=> $album_id,
			'images'    =>$images
		);

		if (!$this->request->is_ajax()) {
			$this->set_template_part('head', 'list_images_head');
			$this->set_template_part('sidebar', 'list_images_sidebar');
			$this->display_template('list_images', $data);
		}
		else {
			$this->load->view('list_images', $data);
		}
    }

    public function upload($album_id) {
		if (count($_FILES) == 0 || !is_uploaded_file($_FILES['data']['tmp_name'])) {
		//Nem sikerult a validalas
			$data = array(
			'album_id'    => $album_id
			);
			//$this->load->view('upload', $data);
			$this->display_template('upload', $data);
		}
		else {
		//Sikerult a validalas
			$data_name = $_FILES['data']['name'];
			//$data_type = $_FILES['data']['type'];
			$data_filename = $_FILES['data']['tmp_name'];

			$uzenet = $this->images_model->insert_image($data_name, $data_filename, $album_id);

			redirect("images/index/$album_id");
		}
    }

    public function download($id) {
		$kep = $this->images_model->get_image($id);
		header("Content-Type: image/jpeg");
		//header("Content-Disposition: attachment; filename={$kep['nev']}");
		echo $kep['data'];
    }

    public function thumb($id) {
		$kep = $this->images_model->get_image($id);
		header("Content-Type: image/jpeg");
		//header("Content-Disposition: attachment; filename={$kep['nev']}");
		echo $kep['thumb'];
    }

	public function delete($id) {
		$uzenet = $this->images_model->delete_image($id);
		if (!$this->request->is_ajax()) {
			$_SESSION['uzenet'] = $uzenet;
			redirect('images/index');
		}
		else {
			$this->load->view('ajax/delete');
		}
	}

	public function index2() {
		$this->load->model('albums_model');
		$albums = $this->albums_model->get_albums();

	    $data = array(
			'albums'    =>$albums
	    );

		$this->set_template_part('head', 'list_images_head');
		$this->set_template_part('sidebar', 'list_images_sidebar');
	    $this->display_template('browse', $data);
	}

}
