$(document).ready(function() {
	/*
	 * Először is tanulmányozni kell a következő view-kat:
	 * - list_images
	 * - list_images_head
	 * - list_images_sidebar
	 * A template miatt, ha ezekre a helyekre szeretnénk dolgozni, akkor ezt így
	 * kell megtennünk. Így oldalanként tudjuk befolyásolni a head, content és
	 * sidebar viselkedését.
	 * A képek egy kepek id-jó div-en belül felsorolásként vannak megadva.
	 * 
	 */

	activate_images();

	$('div.kuka').droppable({ //a kuka osztály lesz a kuka
		accept: "li, div", //miket fogadjon el, először elég a 'li'
		activeClass: "droppable-active", //milyen osztályú legyen, ha elkezdődik a vonszolás
		hoverClass: "droppable-hover", //milyen osztályú legyen, ha fölé érünk
		drop: function(e, ui) {	//Mikor ledobom az elemet, akkor ez hívódik meg
			if (!$(ui.draggable).parent().closest('div').hasClass('rendezo')) {
				var urlarray = $(ui.draggable).find("img").attr('src').split('/');
				var id = urlarray.pop();
				urlarray.pop();
				var url = urlarray.join('/') + '/delete/' + id;
				$.getJSON(
					url,
					function (json) {
						if (json.success) {
							$(ui.draggable).draggable('option', 'revert', false); //ne térjen vissza a draggable
							$(ui.draggable).hide('normal', function () {	//Tűnjön el, és ha eltűnt, akkor
								$(this).remove();	//Szedjük ki a DOM-ból
							});
						}
					}
				);
			}
			else {
				$(ui.draggable).draggable('option', 'revert', false); //ne térjen vissza a draggable
				$(ui.draggable).hide('normal', function () {	//Tűnjön el, és ha eltűnt, akkor
					$(this).remove();	//Szedjük ki a DOM-ból
				});
			}
		}
	});

	$('div.rendezo')
		.droppable({ //a rendező a sidebar-on lesz a slideshow rendező, rá lehet dobni képeket
			accept: "li",
			activeClass: "droppable-active",
			hoverClass: "droppable-hover",
			drop: function(e, ui) {
				$(ui.draggable).draggable('option', 'revert', false);
				$(this).append($("<div></div>").append($(ui.draggable).find('img').eq(0).clone()));
			}
		})
		.sortable(); // és rendezhetővé lehet tenni.

	slideshow_obj.start(); //kezdődjék a show!!!!

	$('#albums ul li').click(function (e) {
		var id = $(this).attr('id').split('_').pop();
		if ($('#images').is(':visible')) {
			$('#images').hide('slide', {direction: 'right'}, 'normal');
		}
		$('#albums')
			.animate({width: '20%'})
			.queue(function () {
				$('#images')
					.load(base_url + 'images/index/' + id, function () {
						//$(this).show('slide', {direction: 'right'}, 1000);
						$(this)
							.width('0%')
							.animate({width: '75%'});
						activate_images();
					});
				$(this).dequeue();
			});
			
		e.stopPropagation();

	});

	$('#albums').click(function () {
		$('#images').hide('slide', {direction: 'right'}, 'normal', function() {
			$('#albums').animate({width: '100%'});
		});
		
	});
});

var slideshow_obj = { //Ezt nem kell így megcsinálni, lehet mindegyiket globális objektumként létrehozni, azaz pl. var timer = null. Csak kísérleteztem az objektumokkal.
	timer: null,
	start: function () {
		$('#slideshow').data('akt', -1);
		this.timer = window.setInterval(this.show, 2000);
		/*
		//enélkül is működik: csak kísérleteztem
		var _show = this.show;
		var self = this;
		this.timer = window.setInterval(function () {
			_show.apply(self);
		}, 1000);
		*/
	},
	show: function () {
		var regi = akt = $('#slideshow').data('akt');
		akt++;
		var hossz = $('div.rendezo > div').length;
		if (akt>=hossz) {
			akt = 0;
		}
		if (hossz>0) {
			$('#slideshow').data('akt', akt);
			if (regi==-1 || regi!=akt) {
				$('#slideshow > img').fadeOut('normal', function() {
					$('#slideshow > img').attr('src', $('div.rendezo > div').eq(akt).children('img').attr('src')).fadeIn();
				});
			}
		}
	}
};

function activate_images() {
	$('#kepek ul li') //Minden kepek-en belüli ul-en belüli li
		.css('opacity', 0.5) // átlátszósága legyen 0.5
		.hover(	//ha fölévisszük vagy lejövünk róla (onmouseover és -out)
			function () { // fölévíve
				//$(this).css('opacity', 1.0); //ne legyen átlátszó
				$(this).stop().fadeTo(500, 1.0); //animálva ne legyen átlátszó (fadeTo), a stop arra szolgál, hogy ha fut közben bármilyen animáció ezen az elemen, akkor azt leállítja --> gyorsabb lesz
				$(this).find('div:first').fadeIn(); //első közelítésben nem kell: az információs kék div jelenjen meg.
			},
			function () { //ha lemegyünk róla
				//$(this).css('opacity', 0.5);
				$(this).stop().fadeTo(500, 0.5); //ld. fentebb
				$(this).find('div:first').fadeOut(); //ld. fentebb
			}
		)
		.prepend('<div>i</div>') //rakjuk hozzá az információs div-et dinamikusan
		.find('div:first') //álljunk rá erre a div-re
			.hide() //első körben nem kell: tüntessük el
			.addClass('info') //adjuk hozzá az info stílusosztályt
			.bind('click', function(e) { //és ha rákattintunk:
				/*
				// a) verzió:
//				var info = $(this).parent().find('div.image_prop'); //keresd meg a kép feliratát
//				if (info.is(':hidden')) { //ha el van rejtve
//					info.slideDown('normal'); //akkor jelenjen meg
//				}
//				else {
//					info.slideUp('normal'); //különben tűnjön el
//				}
//				e.stopPropagation(); //nem adja tovább az eseményt a szülőknek
				*/
			    // b) verzió
				$(this).parent().find('div.image_prop > div').slideToggle('normal'); //a felirat div láthatósága váltakozzék
			});

	$('#kepek ul div.image_prop > div')
		.hide(); //tüntessük el a feliratokat

	$('#slider').slider({	//ez már komponens: egy slidert hoz létre egy div-ből: ezzel fogjuk a képek méretét meghatározni, ld. jqueryui.com a paraméterekhez
		range: 'min',
		min: 0,
		max: 200,
		step: 1,
		value: 0
	});

	$('#kepek ul li img') //ez alternatív, de tanulságos mind css, mind js szempontjából (egyébként inkább css). A képekre menve felnagyulnak. Nincs ilyen jquery effekt, ezért nekünk kell megcsinálnunk. Lényege: a képek egy relative position-ű div-ben vannak. Ha a kép position-je absolute lesz, akkor ehhez képest mozdul el. Ha a kép fölé visszük az egeret, absolute-tá kell tenni őket, de úgy, hogy a kezdeti top, left oda kell állítani, ahol akkor voltak, amikor még a dokumentum része voltak. Ebben sokat segít a jquery. Ezután már csak animálni kell a top, left tulajdonságot.
		.each(function () { //kezdetben  minden képről eltároljuk a helyét és a méretét.
			$(this).data('imgpos', $(this).position())
			$(this).data('imgwidth', $(this).width())
			$(this).data('imgheight', $(this).height())
		})
		.hover(
			function() { //ha fölémegyünk
				if ($('.ui-selecting').length == 0) { //és éppen nincs kiválasztva (ez már nem kell!!!!)
					var imgpos = $(this).data('imgpos'); //kiolvassuk az eltárolt adatokat
					var imgwidth = $(this).data('imgwidth');
					var imgheight = $(this).data('imgheight');
					var magnification = $('#slider').slider('option', 'value') / 100; //slider később is beépíthető
					var offsetleft = imgpos.left-(imgwidth*magnification/2); //kiszámítjuk, mennyire kell eltolni
					var offsettop = imgpos.top-(imgheight*magnification/2);

					$(this).css({	//beállítunk bizonyos tulajdonságokat
						'position': 'absolute',
						'z-index': 300,
						'left': imgpos.left,
						'top': imgpos.right
					});
					$(this).stop().animate({ //majd animálunk
						'width': imgwidth * (1 + magnification),
						'left': offsetleft,
						'top': offsettop
					}, 300);
				}
			},
			function() { //ha lejövünk
				$(this).stop().animate({ //visszaanimálunk az eredeti méretekre
					'width': $(this).data('imgwidth'),
					'left': $(this).data('imgpos').left,
					'top': $(this).data('imgpos').top
				}, 300, 'swing', function () { // és a végeztével
					$(this).css({ //visszaállítunk biz. tulajdonságokat
						'position': 'static',
						'z-index': 1
					});
				});

			}
		);

//	Nem kell, de meg lehet mutatni, hogyan lehetne választhatóvá, vagy rendezhetővé tenni a képeket (egyszerre csak az egyik működik!!!!)
//	$('#kepek ul')
//		//.sortable()
//		.selectable({
//			filter: 'li',
//			distance: 0
//		});

	$('#kepek li')
		.draggable({ //tegyük vonszolhatóvá a képeket
			//helper: 'clone',	//vagy az egészet vonszoljuk
			'helper': function() { //vagy csak a képet
				var imgwidth = $(this).find('img').eq(0).data('imgwidth');
				return $(this).find('img').eq(0).clone().css('width', imgwidth);
			},
			revert: true, //ha elengedjük, térjen vissza
			cursorAt: { //hol legyen vonszoláskor a kurzor
				top: 0,
				left: 0
			},
			scroll: true //lehessen görgetni a dokumentumot
		});
}